const path = require('path');

// 清空文件夹
const {CleanWebpackPlugin} = require('clean-webpack-plugin');

// 查看打包情况
// const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;

const config = {

  // 模式，使用webpack4的优化功能
  mode: 'production',

  // 入口
  entry: {
    index: "./src/index.js",
  },

  module: {
    rules: [
      {
        test: /\.js$/,
        exclude: /node_modules/,
        use: 'babel-loader'
      },
    ]
  },

  plugins: [

    // 清空文件夹
    new CleanWebpackPlugin(),
    // 查看打包情况
    // new BundleAnalyzerPlugin(),
  ],

  output: {

    // 组件采用UMD格式打包
    libraryTarget: "umd",
    // 组件名称
    library: "@sunjingao/underscore",

    // 输出目录
    path: path.join(__dirname, "./dist"),

    // 文件名称
    filename: "[name].js",

    // 按需加载模块时输出的文件名称
    chunkFilename: "js/[name]-[chunkhash:8].js"
  }

};

module.exports = config;
